#if 0
/* 
 * CalibrationSensor
 * 
 * Manon Malique 2024
 * 
 * 
 * 
 * 
 * si la calibration a déjà été faite ET que les données sont toujours pas bonnes (après) ALORS pas linéaire
 */
#include <ArduinoJson.h>
#include <iostream>
#include <map>
#include <string>


#include <driver_display.h> // To retrieve the variant shared root                                                                          

class CalibrationSensor {
public:
    // Constructor
    CalibrationSensor(DynamicJsonDocument& sharedRoot) : dataJson(sharedRoot) { 
        Serial.println("[CalibrationSensor] Constructor called!");
    }

    //DynamicJsonDocument getsharedRoot(){
    //  return dataJson;
    //}

    // Display the JSON file
    void display() {
        String output;
        serializeJsonPretty(dataJson, output);
        Serial.println("[CalibrationSensor]\n" + output);
    }

    // Return the temperature and display for debugging (return -1000 if sensorNumber not in the devices of sharedRoot)
    float extractTemperature(String sensorNumber) {
        if (dataJson.containsKey(sensorNumber)) { // Check if the sensor is present in the JSON file
            Serial.println("[CalibrationSensor] Sensor #" + String(sensorNumber) + " is present in the JSON !");
            float temperature = dataJson["temperature"][sensorNumber];
            return temperature;
        } else {
            Serial.println("[CalibrationSensor] Error! Sensor #" + String(sensorNumber) + " is not in the JSON !");
            return -1000;
        }
    }
    
    //Convert the sharedRoot JsonVariant to DynamicJsonDocument                 
    void copyVariantToDocument(JsonVariant& variant) {
        String json; // test             json="{\"device\":{},\"temperature\":{\"value_units\": \"°c\",\"68\":22.98999977},\"humidity\": {\"value_units\":\"%r.H.\",\"68\":45},\"digital\":{},\"display\":{}}";
            
        // JsonVariant -> JSON String
        serializeJson(variant, json);                                                                                                       
        // JSON String -> DynamicJsonDocument
        deserializeJson(dataJson, json);
    }

    void test(String sensorNumber){
        // Display the temperature
        Serial.println("\n[CalibrationSensor] Temperature test : "+ String(extractTemperature(sensorNumber))+" °C "); // Another way to write it => std::cout << "\n[CalibrationSensor] Temperature test: " << extractTemperature(var) << "°C "<< std::endl;
        // Display the date and the time
        //Serial.println("\n[CalibrationSensor] Time and date test : " + String(extractTime()));
    }
    //Calibrate a neOSensor 
    //  prereq: Verify that the sensor has 2 mesures of temperature
    //float calibration(String sensorNumber) {
    //    
    //}

private:
    DynamicJsonDocument& dataJson;
};

void setup() {
    Serial.begin(115200);
    Serial.println("hello");

    extern DynamicJsonDocument sharedRoot;  //
    CalibrationSensor sensor();

    sensor.display();  //ONLY FOR DEBUG


    /*
    // Declaration and initialization of allData
    DynamicJsonDocument allData(2048);
    const char* jsonAllData = "{\"devices\":{}}";
    deserializeJson(allData, jsonAllData);

    
    //----------------   TEST - Only with the neOSensor#68   ----------------

    // TEST - There's no device called 68
    if (!allData["devices"].containsKey("68")){
        allData["devices"]["68"] = JsonArray();
    }
    JsonArray list = allData["devices"]["68"].as<JsonArray>();
    // TEST - The list has not been created yet
    if (list.isNull()) {
        allData["devices"]["68"] = JsonArray();
        list = allData["devices"]["68"].to<JsonArray>();
    }
    
    // TEST - The list length's has to be 2
    if (list.length()<2){
        list.add(extractTemperature("68"));
    }elif(list.length()==2){
        float temp2 = list[1];
        list[0] = temp2;
        list[1] = curSensor; 
    }
    
    // Serialize the modified JSON document
    String output;
    serializeJsonPretty(allData, output);

    // Display the modified JSON object
    Serial.println(output);
    */
}

void loop() {}



#end